<template>
  <div class="app">
    <div class="stage-wrapper" ref="stage-wrapper">
      <div class="stage-y-axis" />
      <div class="stage-x-axis" />
      <k2-stage 
        :config="stageConfig" 
        ref="stage"
        @dragstart="handleDragStart"
        @dragend="handleDragEnd"
        @mousedown="handleStageMouseDown"
        @touchstart="handleStageMouseDown"
        >
        <k2-layer ref="layer">
          <component v-for="(element, key) in elements" :is="'k2-'+element.type" :key="key" :config="getElementDynamicConfig(element)" @transformend="handleTransformEnd"/>
          <k2-transformer ref="transformer" :config="{rotateEnabled: false}" />
        </k2-layer>
      </k2-stage>
      <button v-if="elements.length" @click="centerElements">
        <span v-if="selectedNode">
            Center element
        </span>
        <span v-else>
            Center all elements
        </span>
      </button>
    </div>
    <div class="controls" @click="unselectElement">

      <!-- New items panel -->
      <div class="add" v-if="!selectedNode">
        <!-- new text -->
        <div class="control">
          <h3>New text</h3>
          <textarea v-model="text" @click.stop placeholder="Add a text"></textarea>
          <button @click.stop="addText" v-if="text && text != ''">Add Text</button>
        </div>
        <!-- new image -->
        <div class="control">
          <h3>New Image</h3>
          <div class="margin-bottom"><input class="input-image" type="file" @change="previewFiles"></div>
          <div class="margin-bottom" v-if="previewImage">
            <img :src="previewImage" class="preview-image" />
          </div>
          <button @click.stop="addImage" v-if="previewImage">Add Image</button>
          <TButton>Hola</TButton>
        </div>
      </div>

      <!-- Edit panel -->
      <div class="edit" v-else :key="selectedElementId">

        <!-- edit text -->
        <div class="control" @click.stop v-if="selectedElement.type == 'text'">
          <h3>Update selected text</h3>
          <textarea :value="selectedElement.config.text" @input="({target}) => updateSelectedElement({text: target.value})" ref="editTextarea"></textarea>

          <h4>Font Family</h4>
          <div class="control-row">
            <select @input="({target}) => updateFontFamily(target.value)">
              <option v-for="family in fontFamilies" :key="family" :value="family" :selected="selectedElement.config.fontFamily == family">{{family}}</option>
            </select>
          </div>

          <h4>Font Style</h4>
          <div class="control-row">
            <select @input="({target}) => updateFontStyle(target.value)">
              <option v-for="style in fontStyles" :key="style" :value="style" :selected="selectedElement.config.fontStyle == style">{{style}}</option>
            </select>
          </div>

          <h4>Font Size</h4>
          <div class="control-row">
            <range-slider
              class="slider"
              min="5"
              max="300"
              step="1"
              :value="selectedElement.config.fontSize" @input="val => updateSelectedElement({fontSize: val})" />
            <div>{{parseInt(selectedElement.config.fontSize)}}pts</div>
          </div>

          <h4>Scale X</h4>
          <div class="control-row">
            <range-slider
              class="slider"
              min="0.1"
              max="10"
              step="0.1"
              :value="selectedElement.config.scaleX" @input="val => updateSelectedElement({scaleX: val})" />
            <div>{{parseInt(selectedElement.config.scaleX * 100)}}%</div>
          </div>

          <h4>Scale Y</h4>
          <div class="control-row">
            <range-slider
              class="slider"
              min="0.1"
              max="10"
              step="0.1"
              :value="selectedElement.config.scaleY" @input="val => updateSelectedElement({scaleY: val})" />
            <div>{{parseInt(selectedElement.config.scaleY * 100)}}%</div>
          </div>
        </div>

        <!--edit image-->
        <div class="control" @click.stop v-if="selectedElement.type == 'image'">
          <h3>Edit image</h3>
       
          <h4>Scale X</h4>
          <div class="control-row">
            <range-slider
              class="slider"
              min="0.1"
              max="10"
              step="0.1"
              :value="selectedElement.config.scaleX" @input="val => updateSelectedElement({scaleX: val})" />
            <div>{{parseInt(selectedElement.config.scaleX * 100)}}%</div>
          </div>

          <h4>Scale Y</h4>
          <div class="control-row">
            <range-slider
              class="slider"
              min="0.1"
              max="10"
              step="0.1"
              :value="selectedElement.config.scaleY" @input="val => updateSelectedElement({scaleY: val})" />
            <div>{{parseInt(selectedElement.config.scaleY * 100)}}%</div>
          </div>
        </div>


        <!--back & delete-->
        <div class="control-row margin-top" style="justify-content:space-between;">
          <button @click="unselectElement">← Back</button>
          <button @click.stop="deleteSelectedElement" class="delete">Delete</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import RangeSlider from 'vue-range-slider'
import 'vue-range-slider/dist/vue-range-slider.css'

export default {
  components: {
    RangeSlider
  },
  data() {
    return {
      newUid: 0,
      zIndex: 0,
      isDragging: false,
      elements: [],
      stageConfig: {
        width: window.innerWidth / 2,
        height: window.innerHeight
      },
      dragItemId: null,
      selectedNode: null,
      selectedElementId: null,
      text: '',
      previewImage: false,
      fontStyles: [
        'normal',
        'bold',
        'italic'
      ],
      fontFamilies: [
        'Calibri', 
        'Helvetica', 
        'Arial',
        'Verdana',
        'Tahoma',
        'Trebuchet MS',
        'Times New Roman', 
        'Georgia',
        'Garamond',
        'Courier New',
        'Brush Script MT'
      ]
    };
  },
  computed: {
    selectedElement(){
      return this.getElementById(this.selectedElementId)
    }
  },
  methods: {
    moveIndex(arr, old_index, new_index) {
      while (old_index < 0) {
          old_index += arr.length;
      }
      while (new_index < 0) {
          new_index += arr.length;
      }
      if (new_index >= arr.length) {
          var k = new_index - arr.length + 1;
          while (k--) {
              arr.push(undefined);
          }
      }
      arr.splice(new_index, 0, arr.splice(old_index, 1)[0]);
      return arr; // for testing purposes
    },
    moveElementIndexToLast(index){
      this.elements.push(this.elements.splice(index, 1)[0]);
      this.selectedNode = this.$refs.stage.getNode().findOne('.' + this.selectedElementId)
    },
    refreshElements(){
      this.elements = [...[], ...this.elements]
    },
    addText(){
      if(!this.text || this.text === '') return alert('Please add some text :)')
      this.createElement({
          type: 'text',
          config: {
            fontStyle: 'normal',
            x: 100,
            y: 100,
            text: this.text,
            fontSize: 30,
            fontFamily: 'Calibri',
            fill: 'black'
          }
        })
      this.text = ''
    },

    previewFiles(e) {
      if (e.target.files && e.target.files[0]) {
        var reader = new FileReader();
        
        reader.onload = e => {
          this.previewImage = e.target.result
        }
        
        reader.readAsDataURL(e.target.files[0]);
      }

      return false;
    },

    addImage(){
      if(!this.previewImage) return alert('Please upload an image :)')
      const image = new Image();
      var self = this
      image.onload = function() {
        self.createElement({
          type: 'image',
          config: {
            x: 100,
            y: 100,
            image,
            width: self.stageConfig.width/2,
            height: (self.stageConfig.width/2)/this.width * this.height,
          }
        })
        self.previewImage = false
      }
      image.src = this.previewImage;
    },
    updateFontFamily(fontFamily){
      const id = this.selectedElementId
      this.updateSelectedElement({ fontFamily })
      this.unselectElement()
      this.$nextTick(() => {
        this.selectedElementId = id
        this.updateTransformer()
      })
    },
    updateFontStyle(fontStyle){
      const id = this.selectedElementId
      this.updateSelectedElement({ fontStyle })
      this.unselectElement()
      this.$nextTick(() => {
        this.selectedElementId = id
        this.updateTransformer()
      })
    },
    getUid(){
      this.newUid++;
      return 'k2-'+this.newUid
    },
    createElement(element){
      const id = this.getUid()
      element.config = {
            id,
            name: id,
            scaleX: 1,
            scaleY: 1,
            draggable: true,
            ...element.config
        }
      this.elements.push(element)
      this.selectedElementId = id
      this.$nextTick(() => {
        this.updateTransformer()
        this.centerElements()
      })
    },
    getElementDynamicConfig({ type, config}){

      var dynamicConfig = {}

      switch(type){
        case 'text':
          dynamicConfig.fill = this.isDragging === config.id ? 'rgba(0,0,0,0.5)' : 'black'
          break
      }
    
      return { ...config, ...dynamicConfig }
    },
    getElementById(id){
      return this.elements.find((r, k) => {
        r.index = k
        return r.config.id === id
      })
    },
    deleteSelectedElement(){
      if(!this.selectedElement) return
      const index = this.selectedElement.index
      if(!confirm(`Do you want to remove the ${this.selectedElement.type} element?`)) return
      this.unselectElement()
      setTimeout(() => {
        this.elements.splice(index, 1)
        this.refreshElements()
      })
    },
    handleDragStart(e) {
      this.isDragging = e.target.attrs.id;
    },
    handleDragEnd(e) {
      this.isDragging = false;
      this.updateSelectedElement({
        x: e.target.x(),
        y: e.target.y()
      })
    },
    unselectElement(){
      this.selectedElementId = null;
      this.updateTransformer();
    },
    handleStageMouseDown(e) {
      // clicked on stage - clear selection
      if (e.target === e.target.getStage()) {
        this.selectedElementId = null;
        this.updateTransformer();
        return;
      }

      // clicked on transformer - do nothing
      if (e.target.getParent().className === 'Transformer') {
        return;
      }

      // find clicked element by its id
      const id = e.target.id();
      const element = this.getElementById(id);
      if (element) {
        this.selectedElementId = id;
      } else {
        this.selectedElementId = null;
      }
      this.updateTransformer();
    },
    updateTransformer() {
      // here we need to manually attach or detach Transformer node
      const transformerNode = this.$refs.transformer.getNode();
      this.selectedNode = this.$refs.stage.getNode().findOne('.' + this.selectedElementId)

      // do nothing if selected node is already attached
      if (this.selectedNode === transformerNode.node()) {
        return;
      }

      if (this.selectedNode) {
        // attach to another node
        transformerNode.nodes([this.selectedNode])
      } else {
        // remove transformer
        transformerNode.nodes([]);
      }
      transformerNode.getLayer().batchDraw();
      
    },
    handleTransformEnd(e) {
      this.updateSelectedElement({
        x: e.target.x(),
        y: e.target.y(),
        rotation: e.target.rotation(),
        scaleX: e.target.scaleX(),
        scaleY: e.target.scaleY()
      })
    },
    updateSelectedElement(config = {}){
      this.updateElement(this.elements[this.selectedElement.index], config)
    },
    updateElement(el, config){
      Object.keys(config).forEach(key => {
        el.config[key] = config[key]
      })
      //Refresh object
      this.refreshElements()
      this.updateTransformer()
    },
    centerElements(){
      if(this.selectedNode) {
        var elements = [ this.elements[this.selectedElement.index] ]
      } else {
        elements = this.elements
      }
      const stage = this.$refs.stage.getNode().attrs
      const center = {
        w: stage.width / 2,
        h: stage.height / 2
      }
      elements.forEach( ({config}) => {
        const node = this.$refs.stage.getNode().findOne('.' + config.id)
        config.x = center.w - (node.width()*config.scaleX)/2
        config.y = center.h - (node.height()*config.scaleY)/2
      })
      this.refreshElements()
    },

    fitStageIntoParentContainer() {
        var stage = this.$refs.stage.getNode()
        var container = this.$refs['stage-wrapper'].getBoundingClientRect()
        var scaleX = container.width / this.stageConfig.width;
        this.stageConfig.width = container.width
        this.stageConfig.height = container.height
        stage.width(container.width);
        stage.height(container.height);
        stage.scale({ x: scaleX, y: 1 });
        stage.draw();
      }
  },
  
  mounted(){
      window.addEventListener('keydown', e => { 
        if (e.key === "Backspace" || e.key === "Delete") { 
          if(this.$refs.editTextarea && document.activeElement === this.$refs.editTextarea) return
          this.deleteSelectedElement()
        } 
      })

      this.fitStageIntoParentContainer()

      window.addEventListener('resize', this.fitStageIntoParentContainer)
  }
}
</script>

<style>

body {
  width: 100%;
}

.app {
  width: 100%;
  z-index: 99;
  background: white;
}

.stage-wrapper {
  background: rgba(0,0,0,0.1);
  position: fixed;
  top: 0;
  left: 0;
  border-right: 2px dashed black;
  width: 50%;
  overflow: hidden;
  height: 100%;
}

.stage-y-axis {
  position: absolute;
  top: 0;
  left: 50%;
  border-left:1px solid rgba(0,0,0,0.1);
  height: 100%;
}

.stage-x-axis {
  position: absolute;
  top: 50%;
  left: 0;
  border-top:1px solid rgba(0,0,0,0.1);
  width: 100%;
}

.stage-wrapper .konvajs-content,
.stage-wrapper .konvajs-content canvas {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}

button {
 padding: 10px 15px;
 cursor: pointer;
 border-radius: 6px;
}


.stage-wrapper button {
  position: absolute;
  bottom: 15px;
  left: 15px;
  z-index: 9999;
}

button.delete {
  background: rgb(248, 100, 100);
}

button.delete:hover {
  background: red;
}

.controls {
  position: absolute;
  top: 0;
  right: 0;
  width: 50%;
  padding: 40px;
  box-sizing: border-box;
  display: block;
  overflow: hidden;
  height: 100%;
  overflow-y: auto;
}

.control {
  border: 2px dashed black;
  box-sizing: border-box;
  border-radius: 20px;
  min-height: 100px;
  width: 100%;
  padding: 30px;
  margin-bottom: 40px;
}

.control > * {
  max-width: 100%;
  box-sizing: border-box;
}

.control-row {
  display: flex;
}

.control textarea {
  margin-bottom: 15px;
  display: block;
  width: 100%;
  padding: 15px;
  min-height: 100px;
}

.control h3 {
  font-size: 25px;
  margin-bottom: 20px;
  font-family: 'Courier New', Courier, monospace;
  font-weight: bold;
  text-transform: uppercase;
}

.control h4 {
  font-size: 16px;
  margin-top: 30px;
  margin-bottom: 20px;
  font-family: 'Courier New', Courier, monospace;
  font-weight: bold;
  text-transform: uppercase;
}

.control select {
  padding: 5px;
}

.margin-bottom {
  margin-bottom: 20px;
}

.margin-top {
  margin-top: 20px;
}

.input-image {
  padding: 0 5px;
  cursor: pointer;
}

.preview-image {
  display: block;
  max-width: 400px;
}

</style>

